from typing import Optional

from orchestrator.domain.base import ProductBlockModel
from orchestrator.types import SubscriptionLifecycle


class TrunkBlockInactive(ProductBlockModel, lifecycle=[SubscriptionLifecycle.INITIAL], product_block_name="TrunkBlock"):
    trunk_id: Optional[int] = None
    geant_s_sid: Optional[str] = None
    trunk_name: Optional[str] = None


class TrunkBlockProvisioning(TrunkBlockInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    trunk_id: Optional[int] = None
    geant_s_sid: Optional[str] = None
    trunk_name: str


class TrunkBlock(TrunkBlockProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    trunk_id: int
    geant_s_sid: str
    trunk_name: str
