from typing import Optional

from orchestrator.domain.base import ProductBlockModel
from orchestrator.types import SubscriptionLifecycle

from products.product_blocks.trunk import TrunkBlock, TrunkBlockInactive, TrunkBlockProvisioning


class TrunkConfigBlockInactive(ProductBlockModel, lifecycle=[SubscriptionLifecycle.INITIAL], product_block_name="TrunkConfigBlock"):
    trunk: TrunkBlockInactive
    trunk_config_id: Optional[int] = None


class TrunkConfigBlockProvisioning(TrunkConfigBlockInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    trunk: TrunkBlockProvisioning
    trunk_config_id: Optional[int] = None


class TrunkConfigBlock(TrunkConfigBlockProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    trunk: TrunkBlock
    trunk_config_id: int
